﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Services;
using System.Web.Script.Services;
using WebPortal.Controls;
using System.Diagnostics;

public partial class _Default : System.Web.UI.Page
{
    protected void Page_Load(int pageSize, int page)
    {
        Debug.WriteLine("Page" + page);
    }

    [WebMethod]
    [ScriptMethod(ResponseFormat = ResponseFormat.Json, UseHttpGet = true)]
    public static void GetGridData()
    {
        var queryString = HttpContext.Current.Request.QueryString;

        var requestString = queryString.ToString();
        
        //Get the current page index and page size from the QueryString
        int skip = Convert.ToInt32(HttpContext.Current.Request.QueryString["page"]);
        int take = Convert.ToInt32(HttpContext.Current.Request.QueryString["pageSize"]);


        //get the data source. For this example the data is dynamically generated and then manual paging and sorting is applied
        // In your case you can instead build a query to the database and just return the result.
        DataResult data = new DataResult();
        List<Item> items = new List<Item>();

        for (int i = 20; i >= 0; i--)
        {
            items.Add(new Item() { ID = i, Name = "Name" + i });
        }

        data.Items = items;


        if (requestString.Contains("orderby"))
        {
         
            if (requestString.Contains("ID"))
            {
                if (requestString.Contains("asc"))
                {
                    data.Items = data.Items.OrderBy(x => x.ID).ToList();
                }
                else
                {
                    data.Items = data.Items.OrderByDescending(x => x.ID).ToList();
                }
            }
            else
            {
                if (requestString.Contains("asc"))
                {
                    data.Items = data.Items.OrderBy(x => x.Name).ToList();
                }
                else
                {
                    data.Items = data.Items.OrderByDescending(x => x.Name).ToList();
                }
            }
        }

        //manual paging    
        data.Items = data.Items.Skip(skip * take).Take(take).ToList();

        //this is for paging. The total record count needs to be returnedas part of the response object.
        data.TotalRecordsCount = items.Count;

        HttpContext.Current.Response.Headers.Add("Content-Type", "application/josn; charset=utf-8");
        HttpContext.Current.Response.Clear();
        HttpContext.Current.Response.Write(data.ToJSON());
        HttpContext.Current.Response.Flush();
        HttpContext.Current.Response.End();
    }
}